<html>
<head>
<title>OGRE: Ogre::ControllerManager Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1ControllerManager.html">ControllerManager</a></div>
<h1>Ogre::ControllerManager Class Reference</h1><!-- doxytag: class="Ogre::ControllerManager" --><!-- doxytag: inherits="Ogre::Singleton" -->Class for managing <a class="el" href="classOgre_1_1Controller.html" title="Instances of this class &#39;control&#39; the value of another object in the system...">Controller</a> instances.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreControllerManager_8h-source.html">OgreControllerManager.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::ControllerManager:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1ControllerManager-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#10f4bb90f05406d2a2aba8da2dc8b747">ControllerManager</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#c22a262e1100162f5f9280f59e47cdbb">~ControllerManager</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#9f3982cde857fa24a943d006055fc683">createController</a> (const <a class="el" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a> &amp;src, const <a class="el" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a> &amp;dest, const <a class="el" href="classOgre_1_1SharedPtr.html">ControllerFunctionRealPtr</a> &amp;func)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new controller and registers it with the manager.  <a href="#9f3982cde857fa24a943d006055fc683"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#ee6987d8cf3b28e404ddaf7305746093">createFrameTimePassthroughController</a> (const <a class="el" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a> &amp;dest)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new controller use frame time source and passthrough controller function.  <a href="#ee6987d8cf3b28e404ddaf7305746093"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#f2e310f231acf0c16e49606c067de5fb">clearControllers</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Destroys all the controllers in existence.  <a href="#f2e310f231acf0c16e49606c067de5fb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#dec63ad5547225a6d1023f127205a558">updateAllControllers</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Updates all the registered controllers.  <a href="#dec63ad5547225a6d1023f127205a558"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <br>
<a class="el" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#df59b698017c1bc2af26fa30c0bcfa80">getFrameTimeSource</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a <a class="el" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a> which provides the time since the last frame as a control value source.  <a href="#df59b698017c1bc2af26fa30c0bcfa80"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <br>
<a class="el" href="classOgre_1_1SharedPtr.html">ControllerFunctionRealPtr</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#4cdfe01292213ab51cd22721de5d0474">getPassthroughControllerFunction</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Retrieve a simple passthrough controller function.  <a href="#4cdfe01292213ab51cd22721de5d0474"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#ca387f07522b8a9d0d432483d4d3c01c">createTextureAnimator</a> (<a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *layer, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> sequenceTime)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a texture layer animator controller.  <a href="#ca387f07522b8a9d0d432483d4d3c01c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#59a8e73c5ee11b05b5506ed35759a967">createTextureUVScroller</a> (<a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *layer, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> speed)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a basic time-based texture uv coordinate modifier designed for creating scrolling textures.  <a href="#59a8e73c5ee11b05b5506ed35759a967"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#f5924b16f9b1065603e16afef947352d">createTextureUScroller</a> (<a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *layer, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> uSpeed)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a basic time-based texture u coordinate modifier designed for creating scrolling textures.  <a href="#f5924b16f9b1065603e16afef947352d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#b7eceb56b8f88d6711bb92b89edac320">createTextureVScroller</a> (<a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *layer, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> vSpeed)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a basic time-based texture v coordinate modifier designed for creating scrolling textures.  <a href="#b7eceb56b8f88d6711bb92b89edac320"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#1f82bf242c70d3d07e7bfc36e975e7f2">createTextureRotater</a> (<a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *layer, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> speed)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a basic time-based texture coordinate modifier designed for creating rotating textures.  <a href="#1f82bf242c70d3d07e7bfc36e975e7f2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#db7c1830d90168a153f230bf9185d983">createTextureWaveTransformer</a> (<a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *layer, <a class="el" href="classOgre_1_1TextureUnitState.html#942a1ce66d0909d29ed09c98e9e6d82d">TextureUnitState::TextureTransformType</a> ttype, <a class="el" href="namespaceOgre.html#bf2e0412a783a6f708ca1a58abb45c1b">WaveformType</a> waveType, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> base=0, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> frequency=1, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> phase=0, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> amplitude=1)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a very flexible time-based texture transformation which can alter the scale, position or rotation of a texture based on a wave function.  <a href="#db7c1830d90168a153f230bf9185d983"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#903c5e54329b97dc7bd31af1adde7c26">createGpuProgramTimerParam</a> (<a class="el" href="classOgre_1_1GpuProgramParameters.html">GpuProgramParameters</a> *params, size_t paramIndex, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> timeFactor=1.0f)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a controller for passing a frame time value through to a vertex / fragment program parameter.  <a href="#903c5e54329b97dc7bd31af1adde7c26"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#8101005e37057a9e2b4830f8294d76ad">destroyController</a> (<a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *controller)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Removes &amp; destroys the controller passed in as a pointer.  <a href="#8101005e37057a9e2b4830f8294d76ad"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#22912479acd815fc94365804a8a6238e">getTimeFactor</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return relative speed of time as perceived by time based controllers.  <a href="#22912479acd815fc94365804a8a6238e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#c254afaf3a4086f0b1f4fb5391d48446">setTimeFactor</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> tf)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the relative speed to update frame time based controllers.  <a href="#c254afaf3a4086f0b1f4fb5391d48446"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#66be5a1f5f7fa249d1bbd27d6eaec21d">getFrameDelay</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the constant that is added to time lapsed between each frame.  <a href="#66be5a1f5f7fa249d1bbd27d6eaec21d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#a27ced49b9021563ef663cebdd320191">setFrameDelay</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fd)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets a constant frame rate.  <a href="#a27ced49b9021563ef663cebdd320191"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#7426664951c1f7bc6e42ff5e83cd8ec8">getElapsedTime</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the elapsed time.  <a href="#7426664951c1f7bc6e42ff5e83cd8ec8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#eae665419e95a8b9a250254462297786">setElapsedTime</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> elapsedTime)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the elapsed time.  <a href="#eae665419e95a8b9a250254462297786"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <br>
<a class="el" href="classOgre_1_1ControllerManager.html">ControllerManager</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#68fb107a5e1b3470c7381c0c1fdd36c7">getSingleton</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval.  <a href="#68fb107a5e1b3470c7381c0c1fdd36c7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <br>
<a class="el" href="classOgre_1_1ControllerManager.html">ControllerManager</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#fc3e91410cbc2f77cfff9f9b09ef60f7">getSingletonPtr</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval.  <a href="#fc3e91410cbc2f77cfff9f9b09ef60f7"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::set<br>
&lt; <a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#a48c7d2913101890c3d39921d287729b">ControllerList</a></td></tr>

<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ControllerManager.html#a48c7d2913101890c3d39921d287729b">ControllerList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#d263be2e0db9bbddc6e4587a78f615c8">mControllers</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#555188386569bbacdec2d662b64fd59c">mFrameTimeController</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Global predefined controller.  <a href="#555188386569bbacdec2d662b64fd59c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1SharedPtr.html">ControllerFunctionRealPtr</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#e275d3c92f688de92071a85e24a3f42f">mPassthroughFunction</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Global predefined controller.  <a href="#e275d3c92f688de92071a85e24a3f42f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned long&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ControllerManager.html#630fae68555eb16ed10c282fa5826eb8">mLastFrameNumber</a></td></tr>

<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static T *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#d36ac06b409a2d580217328ef2cd3a01">ms_Singleton</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Class for managing <a class="el" href="classOgre_1_1Controller.html" title="Instances of this class &#39;control&#39; the value of another object in the system...">Controller</a> instances. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This class is responsible to keeping tabs on all the <a class="el" href="classOgre_1_1Controller.html" title="Instances of this class &#39;control&#39; the value of another object in the system...">Controller</a> instances registered and updating them when requested. It also provides a number of convenience methods for creating commonly used controllers (such as texture animators). </dd></dl>

<p>Definition at line <a class="el" href="OgreControllerManager_8h-source.html#l00052">52</a> of file <a class="el" href="OgreControllerManager_8h-source.html">OgreControllerManager.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="a48c7d2913101890c3d39921d287729b"></a><!-- doxytag: member="Ogre::ControllerManager::ControllerList" ref="a48c7d2913101890c3d39921d287729b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::set&lt;<a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt;*&gt; <a class="el" href="classOgre_1_1ControllerManager.html#a48c7d2913101890c3d39921d287729b">Ogre::ControllerManager::ControllerList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreControllerManager_8h-source.html#l00055">55</a> of file <a class="el" href="OgreControllerManager_8h-source.html">OgreControllerManager.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="10f4bb90f05406d2a2aba8da2dc8b747"></a><!-- doxytag: member="Ogre::ControllerManager::ControllerManager" ref="10f4bb90f05406d2a2aba8da2dc8b747" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::ControllerManager::ControllerManager           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="c22a262e1100162f5f9280f59e47cdbb"></a><!-- doxytag: member="Ogre::ControllerManager::~ControllerManager" ref="c22a262e1100162f5f9280f59e47cdbb" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::ControllerManager::~ControllerManager           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="9f3982cde857fa24a943d006055fc683"></a><!-- doxytag: member="Ogre::ControllerManager::createController" ref="9f3982cde857fa24a943d006055fc683" args="(const ControllerValueRealPtr &amp;src, const ControllerValueRealPtr &amp;dest, const ControllerFunctionRealPtr &amp;func)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt;* Ogre::ControllerManager::createController           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>dest</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">ControllerFunctionRealPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>func</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new controller and registers it with the manager. 
<p>

</div>
</div><p>
<a class="anchor" name="ee6987d8cf3b28e404ddaf7305746093"></a><!-- doxytag: member="Ogre::ControllerManager::createFrameTimePassthroughController" ref="ee6987d8cf3b28e404ddaf7305746093" args="(const ControllerValueRealPtr &amp;dest)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt;* Ogre::ControllerManager::createFrameTimePassthroughController           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>dest</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new controller use frame time source and passthrough controller function. 
<p>

</div>
</div><p>
<a class="anchor" name="f2e310f231acf0c16e49606c067de5fb"></a><!-- doxytag: member="Ogre::ControllerManager::clearControllers" ref="f2e310f231acf0c16e49606c067de5fb" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ControllerManager::clearControllers           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Destroys all the controllers in existence. 
<p>

</div>
</div><p>
<a class="anchor" name="dec63ad5547225a6d1023f127205a558"></a><!-- doxytag: member="Ogre::ControllerManager::updateAllControllers" ref="dec63ad5547225a6d1023f127205a558" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ControllerManager::updateAllControllers           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Updates all the registered controllers. 
<p>

</div>
</div><p>
<a class="anchor" name="df59b698017c1bc2af26fa30c0bcfa80"></a><!-- doxytag: member="Ogre::ControllerManager::getFrameTimeSource" ref="df59b698017c1bc2af26fa30c0bcfa80" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a>&amp; Ogre::ControllerManager::getFrameTimeSource           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a <a class="el" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a> which provides the time since the last frame as a control value source. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>A common source value to use to feed into a controller is the time since the last frame. This method returns a pointer to a common source value which provides this information. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Remember the value will only be up to date after the RenderSystem::beginFrame method is called. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd>RenderSystem::beginFrame </dd></dl>

</div>
</div><p>
<a class="anchor" name="4cdfe01292213ab51cd22721de5d0474"></a><!-- doxytag: member="Ogre::ControllerManager::getPassthroughControllerFunction" ref="4cdfe01292213ab51cd22721de5d0474" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1SharedPtr.html">ControllerFunctionRealPtr</a>&amp; Ogre::ControllerManager::getPassthroughControllerFunction           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Retrieve a simple passthrough controller function. 
<p>

</div>
</div><p>
<a class="anchor" name="ca387f07522b8a9d0d432483d4d3c01c"></a><!-- doxytag: member="Ogre::ControllerManager::createTextureAnimator" ref="ca387f07522b8a9d0d432483d4d3c01c" args="(TextureUnitState *layer, Real sequenceTime)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt;* Ogre::ControllerManager::createTextureAnimator           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *&nbsp;</td>
          <td class="paramname"> <em>layer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>sequenceTime</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a texture layer animator controller. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This helper method creates the <a class="el" href="classOgre_1_1Controller.html" title="Instances of this class &#39;control&#39; the value of another object in the system...">Controller</a>, <a class="el" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a> and <a class="el" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value...">ControllerFunction</a> classes required to animate a texture. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>layer</em>&nbsp;</td><td><a class="el" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a> object to animate </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>sequenceTime</em>&nbsp;</td><td>The amount of time in seconds it will take to loop through all the frames. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="59a8e73c5ee11b05b5506ed35759a967"></a><!-- doxytag: member="Ogre::ControllerManager::createTextureUVScroller" ref="59a8e73c5ee11b05b5506ed35759a967" args="(TextureUnitState *layer, Real speed)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt;* Ogre::ControllerManager::createTextureUVScroller           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *&nbsp;</td>
          <td class="paramname"> <em>layer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>speed</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a basic time-based texture uv coordinate modifier designed for creating scrolling textures. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This simple method allows you to easily create constant-speed uv scrolling textures. If you want to specify different speed values for horizontal and vertical scroll, use the specific methods <a class="el" href="classOgre_1_1ControllerManager.html#f5924b16f9b1065603e16afef947352d" title="Creates a basic time-based texture u coordinate modifier designed for creating scrolling...">ControllerManager::createTextureUScroller</a> and <a class="el" href="classOgre_1_1ControllerManager.html#b7eceb56b8f88d6711bb92b89edac320" title="Creates a basic time-based texture v coordinate modifier designed for creating scrolling...">ControllerManager::createTextureVScroller</a>. If you want more control, look up the <a class="el" href="classOgre_1_1ControllerManager.html#db7c1830d90168a153f230bf9185d983" title="Creates a very flexible time-based texture transformation which can alter the scale...">ControllerManager::createTextureWaveTransformer</a> for more complex wave-based scrollers / stretchers / rotaters. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>layer</em>&nbsp;</td><td>The texture layer to animate. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>speed</em>&nbsp;</td><td>Speed of horizontal (u-coord) and vertical (v-coord) scroll, in complete wraps per second </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="f5924b16f9b1065603e16afef947352d"></a><!-- doxytag: member="Ogre::ControllerManager::createTextureUScroller" ref="f5924b16f9b1065603e16afef947352d" args="(TextureUnitState *layer, Real uSpeed)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt;* Ogre::ControllerManager::createTextureUScroller           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *&nbsp;</td>
          <td class="paramname"> <em>layer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>uSpeed</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a basic time-based texture u coordinate modifier designed for creating scrolling textures. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This simple method allows you to easily create constant-speed u scrolling textures. If you want more control, look up the <a class="el" href="classOgre_1_1ControllerManager.html#db7c1830d90168a153f230bf9185d983" title="Creates a very flexible time-based texture transformation which can alter the scale...">ControllerManager::createTextureWaveTransformer</a> for more complex wave-based scrollers / stretchers / rotaters. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>layer</em>&nbsp;</td><td>The texture layer to animate. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>uSpeed</em>&nbsp;</td><td>Speed of horizontal (u-coord) scroll, in complete wraps per second </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="b7eceb56b8f88d6711bb92b89edac320"></a><!-- doxytag: member="Ogre::ControllerManager::createTextureVScroller" ref="b7eceb56b8f88d6711bb92b89edac320" args="(TextureUnitState *layer, Real vSpeed)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt;* Ogre::ControllerManager::createTextureVScroller           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *&nbsp;</td>
          <td class="paramname"> <em>layer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>vSpeed</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a basic time-based texture v coordinate modifier designed for creating scrolling textures. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This simple method allows you to easily create constant-speed v scrolling textures. If you want more control, look up the <a class="el" href="classOgre_1_1ControllerManager.html#db7c1830d90168a153f230bf9185d983" title="Creates a very flexible time-based texture transformation which can alter the scale...">ControllerManager::createTextureWaveTransformer</a> for more complex wave-based scrollers / stretchers / rotaters. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>layer</em>&nbsp;</td><td>The texture layer to animate. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>vSpeed</em>&nbsp;</td><td>Speed of vertical (v-coord) scroll, in complete wraps per second </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="1f82bf242c70d3d07e7bfc36e975e7f2"></a><!-- doxytag: member="Ogre::ControllerManager::createTextureRotater" ref="1f82bf242c70d3d07e7bfc36e975e7f2" args="(TextureUnitState *layer, Real speed)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt;* Ogre::ControllerManager::createTextureRotater           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *&nbsp;</td>
          <td class="paramname"> <em>layer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>speed</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a basic time-based texture coordinate modifier designed for creating rotating textures. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>This simple method allows you to easily create constant-speed rotating textures. If you want more control, look up the <a class="el" href="classOgre_1_1ControllerManager.html#db7c1830d90168a153f230bf9185d983" title="Creates a very flexible time-based texture transformation which can alter the scale...">ControllerManager::createTextureWaveTransformer</a> for more complex wave-based scrollers / stretchers / rotaters. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>layer</em>&nbsp;</td><td>The texture layer to rotate. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>vSpeed</em>&nbsp;</td><td>Speed of rotation, in complete anticlockwise revolutions per second </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="db7c1830d90168a153f230bf9185d983"></a><!-- doxytag: member="Ogre::ControllerManager::createTextureWaveTransformer" ref="db7c1830d90168a153f230bf9185d983" args="(TextureUnitState *layer, TextureUnitState::TextureTransformType ttype, WaveformType waveType, Real base=0, Real frequency=1, Real phase=0, Real amplitude=1)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt;* Ogre::ControllerManager::createTextureWaveTransformer           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *&nbsp;</td>
          <td class="paramname"> <em>layer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TextureUnitState.html#942a1ce66d0909d29ed09c98e9e6d82d">TextureUnitState::TextureTransformType</a>&nbsp;</td>
          <td class="paramname"> <em>ttype</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#bf2e0412a783a6f708ca1a58abb45c1b">WaveformType</a>&nbsp;</td>
          <td class="paramname"> <em>waveType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>base</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>frequency</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>phase</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>amplitude</em> = <code>1</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a very flexible time-based texture transformation which can alter the scale, position or rotation of a texture based on a wave function. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>layer</em>&nbsp;</td><td>The texture layer to affect </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>ttype</em>&nbsp;</td><td>The type of transform, either translate (scroll), scale (stretch) or rotate (spin) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>waveType</em>&nbsp;</td><td>The shape of the wave, see WaveformType enum for details </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>base</em>&nbsp;</td><td>The base value of the output </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>frequency</em>&nbsp;</td><td>The speed of the wave in cycles per second </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>phase</em>&nbsp;</td><td>The offset of the start of the wave, e.g. 0.5 to start half-way through the wave </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>amplitude</em>&nbsp;</td><td>Scales the output so that instead of lying within 0..1 it lies within 0..1*amplitude for exaggerated effects </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="903c5e54329b97dc7bd31af1adde7c26"></a><!-- doxytag: member="Ogre::ControllerManager::createGpuProgramTimerParam" ref="903c5e54329b97dc7bd31af1adde7c26" args="(GpuProgramParameters *params, size_t paramIndex, Real timeFactor=1.0f)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&gt;* Ogre::ControllerManager::createGpuProgramTimerParam           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GpuProgramParameters.html">GpuProgramParameters</a> *&nbsp;</td>
          <td class="paramname"> <em>params</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>paramIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>timeFactor</em> = <code>1.0f</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a controller for passing a frame time value through to a vertex / fragment program parameter. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The destination parameter is expected to be a float, and the '.x' attribute will be populated with the appropriately scaled time value. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>params</em>&nbsp;</td><td>The parameters to update </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>paramIndex</em>&nbsp;</td><td>The index of the parameter to update; if you want a named parameter, then retrieve the index beforehand using GpuProgramParameters::getParamIndex </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>factor</em>&nbsp;</td><td>The factor by which to adjust the time elapsed by before passing it to the program </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="8101005e37057a9e2b4830f8294d76ad"></a><!-- doxytag: member="Ogre::ControllerManager::destroyController" ref="8101005e37057a9e2b4830f8294d76ad" args="(Controller&lt; Real &gt; *controller)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ControllerManager::destroyController           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Controller.html">Controller</a>&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; *&nbsp;</td>
          <td class="paramname"> <em>controller</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Removes &amp; destroys the controller passed in as a pointer. 
<p>

</div>
</div><p>
<a class="anchor" name="22912479acd815fc94365804a8a6238e"></a><!-- doxytag: member="Ogre::ControllerManager::getTimeFactor" ref="22912479acd815fc94365804a8a6238e" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::ControllerManager::getTimeFactor           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Return relative speed of time as perceived by time based controllers. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>See setTimeFactor for full information on the meaning of this value. </dd></dl>

</div>
</div><p>
<a class="anchor" name="c254afaf3a4086f0b1f4fb5391d48446"></a><!-- doxytag: member="Ogre::ControllerManager::setTimeFactor" ref="c254afaf3a4086f0b1f4fb5391d48446" args="(Real tf)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ControllerManager::setTimeFactor           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>tf</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Set the relative speed to update frame time based controllers. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Normally any controllers which use time as an input (FrameTimeController) are updated automatically in line with the real passage of time. This method allows you to change that, so that controllers are told that the time is passing slower or faster than it actually is. Use this to globally speed up / slow down the effect of time-based controllers. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>tf</em>&nbsp;</td><td>The virtual speed of time (1.0 is real time). </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="66be5a1f5f7fa249d1bbd27d6eaec21d"></a><!-- doxytag: member="Ogre::ControllerManager::getFrameDelay" ref="66be5a1f5f7fa249d1bbd27d6eaec21d" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::ControllerManager::getFrameDelay           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the constant that is added to time lapsed between each frame. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>See setFrameDelay for full information on the meaning of this value. </dd></dl>

</div>
</div><p>
<a class="anchor" name="a27ced49b9021563ef663cebdd320191"></a><!-- doxytag: member="Ogre::ControllerManager::setFrameDelay" ref="a27ced49b9021563ef663cebdd320191" args="(Real fd)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ControllerManager::setFrameDelay           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>fd</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets a constant frame rate. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This function is useful when rendering a sequence to files that should create a film clip with constant frame rate. It will ensure that scrolling textures and animations move at a constant frame rate. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>fd</em>&nbsp;</td><td>The delay in seconds wanted between each frame (1.0f / 25.0f means a seconds worth of animation is done in 25 frames). </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="7426664951c1f7bc6e42ff5e83cd8ec8"></a><!-- doxytag: member="Ogre::ControllerManager::getElapsedTime" ref="7426664951c1f7bc6e42ff5e83cd8ec8" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::ControllerManager::getElapsedTime           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Return the elapsed time. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>See setElapsedTime for full information on the meaning of this value. </dd></dl>

</div>
</div><p>
<a class="anchor" name="eae665419e95a8b9a250254462297786"></a><!-- doxytag: member="Ogre::ControllerManager::setElapsedTime" ref="eae665419e95a8b9a250254462297786" args="(Real elapsedTime)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ControllerManager::setElapsedTime           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>elapsedTime</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Set the elapsed time. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Normally elapsed time accumulated all frames time (which speed relative to time factor) since the rendering loop started. This method allows your to change that to special time, so some elapsed-time-based globally effect is repeatable. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>elapsedTime</em>&nbsp;</td><td>The new elapsed time </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="68fb107a5e1b3470c7381c0c1fdd36c7"></a><!-- doxytag: member="Ogre::ControllerManager::getSingleton" ref="68fb107a5e1b3470c7381c0c1fdd36c7" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1ControllerManager.html">ControllerManager</a>&amp; Ogre::ControllerManager::getSingleton           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Why do we do this? Well, it's because the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> template to work, but we actually only want it compiled into the implementation of the class based on the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#7757bd7ac3702c144502e53ad6491888">Ogre::Singleton&lt; T &gt;</a>.</p>

</div>
</div><p>
<a class="anchor" name="fc3e91410cbc2f77cfff9f9b09ef60f7"></a><!-- doxytag: member="Ogre::ControllerManager::getSingletonPtr" ref="fc3e91410cbc2f77cfff9f9b09ef60f7" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1ControllerManager.html">ControllerManager</a>* Ogre::ControllerManager::getSingletonPtr           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Why do we do this? Well, it's because the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> template to work, but we actually only want it compiled into the implementation of the class based on the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#7ab51c46521b89723d6186a52a7e0d7b">Ogre::Singleton&lt; T &gt;</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="d263be2e0db9bbddc6e4587a78f615c8"></a><!-- doxytag: member="Ogre::ControllerManager::mControllers" ref="d263be2e0db9bbddc6e4587a78f615c8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ControllerManager.html#a48c7d2913101890c3d39921d287729b">ControllerList</a> <a class="el" href="classOgre_1_1ControllerManager.html#d263be2e0db9bbddc6e4587a78f615c8">Ogre::ControllerManager::mControllers</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreControllerManager_8h-source.html#l00056">56</a> of file <a class="el" href="OgreControllerManager_8h-source.html">OgreControllerManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="555188386569bbacdec2d662b64fd59c"></a><!-- doxytag: member="Ogre::ControllerManager::mFrameTimeController" ref="555188386569bbacdec2d662b64fd59c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a> <a class="el" href="classOgre_1_1ControllerManager.html#555188386569bbacdec2d662b64fd59c">Ogre::ControllerManager::mFrameTimeController</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Global predefined controller. 
<p>

<p>Definition at line <a class="el" href="OgreControllerManager_8h-source.html#l00059">59</a> of file <a class="el" href="OgreControllerManager_8h-source.html">OgreControllerManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e275d3c92f688de92071a85e24a3f42f"></a><!-- doxytag: member="Ogre::ControllerManager::mPassthroughFunction" ref="e275d3c92f688de92071a85e24a3f42f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SharedPtr.html">ControllerFunctionRealPtr</a> <a class="el" href="classOgre_1_1ControllerManager.html#e275d3c92f688de92071a85e24a3f42f">Ogre::ControllerManager::mPassthroughFunction</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Global predefined controller. 
<p>

<p>Definition at line <a class="el" href="OgreControllerManager_8h-source.html#l00062">62</a> of file <a class="el" href="OgreControllerManager_8h-source.html">OgreControllerManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="630fae68555eb16ed10c282fa5826eb8"></a><!-- doxytag: member="Ogre::ControllerManager::mLastFrameNumber" ref="630fae68555eb16ed10c282fa5826eb8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classOgre_1_1ControllerManager.html#630fae68555eb16ed10c282fa5826eb8">Ogre::ControllerManager::mLastFrameNumber</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreControllerManager_8h-source.html#l00065">65</a> of file <a class="el" href="OgreControllerManager_8h-source.html">OgreControllerManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d36ac06b409a2d580217328ef2cd3a01"></a><!-- doxytag: member="Ogre::ControllerManager::ms_Singleton" ref="d36ac06b409a2d580217328ef2cd3a01" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Singleton.html#d36ac06b409a2d580217328ef2cd3a01">ms_Singleton</a><code> [static, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSingleton_8h-source.html#l00061">61</a> of file <a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSingleton_8h-source.html#l00076">Ogre::Singleton&lt; Ogre::FontManager &gt;::getSingleton()</a>, <a class="el" href="OgreSingleton_8h-source.html#l00078">Ogre::Singleton&lt; Ogre::FontManager &gt;::getSingletonPtr()</a>, <a class="el" href="OgreSingleton_8h-source.html#l00064">Ogre::Singleton&lt; Ogre::FontManager &gt;::Singleton()</a>, and <a class="el" href="OgreSingleton_8h-source.html#l00074">Ogre::Singleton&lt; Ogre::FontManager &gt;::~Singleton()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreControllerManager_8h-source.html">OgreControllerManager.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:29 2008
</p>
</body>
</html>
